#include <iostream>
using namespace std; 


struct Nodo {
  int dato; 
  Nodo* enlace;
};


Nodo* busca(Nodo* head, int x) {
/* Pre: head apunta a la cabeza de una cadena de nodos enlazados.
El campo enlace del último nodo de la cadena es nullptr. Si la cadena 
es vacía, entonces head es nullptr. */
/* Post: El resultado es un puntero que apunta al primer nodo de la
cadena que contiene x en el campo dato. Si ningún nodo contiene x, el
resultado es nullptr.  */
  bool found = false; 
  Nodo* here = head; 
  while (not found and here != nullptr) {
    if (here->dato == x) found = true;
    else here = here->enlace;
  }
  return here;
}


void insert_cab(Nodo*& h, int v) 
/* Pre: h apunta a la cabeza de una cadena 
de nodos enlazados */
/* Post: Se ha insertado un nuevo nodo que 
contiene el valor v en la cabeza de la cadena */
{
  Nodo* temp = new Nodo; 
  temp->dato = v; 
  temp->enlace = h; 
  h = temp; 
}


void lee(Nodo*& h) {
  /* Pre: En el canal estándar de entrada hay una secuencia de enteros
     terminada en 0. h apunta a la cabeza de una cadena de nodos enlazados. */
  /* Post: Se han leido los elementos de la secuencia y se han
     insertado secuencialmente en la cabeza de la cadena de nodos
     enlazados. */
  int x;
  cin >> x; 
  while (x != 0) {
    insert_cab(h,x);
    cin >> x;
  }
}


void escribe(Nodo* h) {
/* Pre: h apunta a la cabeza de una cadena 
de nodos enlazados */
/* Post: Se han escrito los datos de los nodos de la cadena a la que
   apunta h */
  for (Nodo* i = h; i != nullptr; i = i->enlace) {
    cout << " " << i->dato; 
  }
  cout << endl;
}


int main() {
  Nodo* head = nullptr; 
  lee(head); 
  
  int v; 
  cin >> v; 
  Nodo* p = busca(head,v); 
  if (p == nullptr) cout << endl << "no encontrado" << endl; 
  else cout << endl << p->dato << " encontrado" << endl;
  
  cout << "cadena ";
  escribe(head);
}
