#include <iostream>
using namespace std; 


struct Nodo {
  int dato; 
  Nodo* enlace;
};


void lee(Nodo*& h) {
  /* Pre: En el canal estándar de entrada hay una secuencia de enteros
     terminada en 0. h=nullptr, i.e apunta a una cadena vacía de nodos
     enlazados. */
  /* Post: La cadena de nodos enlazados apuntada por h contiene los
     elementos que estaban en el canal de estándar de entrada en
     el mismo orden en el que aparecían en la secuencia. */

  Nodo* ultimo = h;
  int x;
  cin >> x; 
  while (x != 0) {
     if (ultimo == nullptr) {
        ultimo = new Nodo; // Crea el primer nodo
        h = ultimo; // Hace que h apunte a él
     }
     else {
	ultimo->enlace = new Nodo; // Crea el siguiente nodo
        ultimo = ultimo->enlace; // Avanza el puntero ultimo
     }
     ultimo->dato = x; // Asigna el dato leido
     ultimo->enlace = nullptr; // Termina la cadena
     cin >> x; 
  }
}


void escribe(Nodo* h) {
/* Pre: h apunta a la cabeza de una cadena 
de nodos enlazados */
/* Post: Se han escrito los elementos de la 
cadena de nodos enlazados a la que apunta h */
  for (Nodo* i = h; i != nullptr; i = i->enlace) {
    cout << " " << i->dato; 
  }
  cout << endl;
}


void avanza(Nodo*& here) {
  if (here != nullptr) here = here->enlace;
}


Nodo* copia(Nodo* h) {
  /* Pre: h apunta a una cadena de nodos enlazados */
  /* Post: Si h es nullptr, el resultado es nullptr; en otro caso, el
     resultado apunta al primer nodo de una cadena de nodos enlazados
     que son copia de los nodos de la cadena apuntada por h. */
  Nodo* c;
  if (h == nullptr) c = nullptr; 
  else {
     c = new Nodo; 
     c->dato = h->dato; 
     c->enlace = copia(h->enlace);    
  }
  return c;
}


int main() {
  Nodo* head = nullptr; 
  lee(head); 

  // Descomentar la línea  Nodo* head2 = head;
  // y comentar Nodo* head2 = copia(head);
  // para ver qué ocurre
  
  //  Nodo* head2 = head; // head y head2 son el mismo objeto (aliasing)

  Nodo* head2 = copia(head); // head2 apunta a un objeto independiente 
                             // del objeto al que apunta head.
  // Los datos de la cadena de nodos apuntada por head son iguales a
  // los datos de la cadena apuntada por head2.

  Nodo* here = head; 
  avanza(here);
  int x; 
  cin >> x; 
  here->dato = x; // Modifica la cadena apuntada por head, pero no 
  // modifica la cadena apuntada por head2, ya que son independientes.

  cout << "cadena apuntada por head ";
  escribe(head);
  cout << "cadena apuntada por head2 ";
  escribe(head2);
}
