#include <iostream>
using namespace std; 


struct Nodo {
  int dato; 
  Nodo* enlace;
};


void elimina(Nodo*& head, Nodo* discard, Nodo* before) {
/* Pre: head apunta a la cabeza de una cadena de nodos enlazados no
vacía. discard apunta a un nodo de dicha cadena de nodos enlazados. 
Si discard es distinto de head, before apunta al nodo anterior al 
nodo apuntado por discard; en otro caso, before es nullptr */
/* Post: Se ha borrado de la cadena apuntada por head el nodo 
   apuntado por discard. */
  if (discard == head) head = head->enlace;
  else before->enlace = discard->enlace;

  delete discard;
}


// Ejercicio: Implementad elimina pasando sólo head y discard como
// argumentos. En la precondición se especifica que discard no puede 
// apuntar a nullptr.


void lee(Nodo*& h) {
  /* Pre: En el canal estándar de entrada hay una secuencia de enteros
     terminada en 0. h=nullptr, i.e apunta a una cadena vacía de nodos
     enlazados. */
  /* Post: La cadena de nodos enlazados apuntada por h contiene los
     elementos que estaban en el canal de estándar de entrada en
     el mismo orden en el que aparecían en la secuencia. */

  Nodo* ultimo = h;
  int x;
  cin >> x; 
  while (x != 0) {
     if (ultimo == nullptr) {
        ultimo = new Nodo; // Crea el primer nodo
        h = ultimo; // Hace que h apunte a él
     }
     else {
	ultimo->enlace = new Nodo; // Crea el siguiente nodo
        ultimo = ultimo->enlace; // Avanza el puntero ultimo
     }
     ultimo->dato = x; // Asigna el dato leido
     ultimo->enlace = nullptr; // Termina la cadena
     cin >> x; 
  }
}


void avanza(Nodo*& here) {
  /* Pre: here = HERE, here apunta a un nodo de una cadena no vacía de
     nodos enlazados. */
  /* Post: Si HERE no apunta al último nodo de dicha cadena, here
     apunta al nodo siguiente al apuntado por HERE; en otro caso here 
     es nullptr. */
   here = here->enlace;
}


void escribe(Nodo* h) {
/* Pre: h apunta a la cabeza de una cadena 
de nodos enlazados */
/* Post: Se han escrito los elementos de la 
cadena de nodos enlazados a la que apunta h */
  for (Nodo* i = h; i != nullptr; i = i->enlace) {
    cout << " " << i->dato; 
  }
  cout << endl;
}


int main() {
  Nodo* head = nullptr; 
  lee(head); 
  cout << "cadena ";
  escribe(head);
  
  Nodo* discard = head; 
  avanza(discard);
  avanza(discard);
  avanza(discard);
  cout << "borrar " << discard->dato << endl;
  
  Nodo* before = head;  
  avanza(before);
  avanza(before);

  elimina(head,discard,before);
  
  // Para borrar el primer nodo
  // elimina(head,head,nullptr);
  cout << "cadena ";
  escribe(head);
}
