#include <iostream>
using namespace std; 


struct Nodo {
  int dato; 
  Nodo* enlace;
};


void insert_after(Nodo*& after_me, int x) {
/* Pre: after_me = AFTER_ME, AFTER_ME apunta a un nodo de una cadena
   de nodos enlazados. */
/* Post: Se ha insertado en la cadena un nuevo nodo con dato x detrás
del nodo al que apuntaba AFTER_ME. */
  Nodo* temp_ptr = new Nodo; 
  temp_ptr->dato = x; 
  
  // El orden de las siguientes instrucciones es crucial. 
  temp_ptr->enlace = after_me->enlace; 
  after_me->enlace = temp_ptr;
}



void lee(Nodo*& h) {
  /* Pre: En el canal estándar de entrada hay una secuencia de enteros
     terminada en 0. h=nullptr, i.e apunta a una cadena vacía de nodos
     enlazados. */
  /* Post: La cadena de nodos enlazados apuntada por h contiene los
     elementos que estaban en el canal de estándar de entrada en
     el mismo orden en el que aparecían en la secuencia. */

  Nodo* ultimo = h;
  int x;
  cin >> x; 
  while (x != 0) {
     if (ultimo == nullptr) {
        ultimo = new Nodo; // Crea el primer nodo
        h = ultimo; // Hace que h apunte a él
     }
     else {
	ultimo->enlace = new Nodo; // Crea el siguiente nodo
        ultimo = ultimo->enlace; // Avanza el puntero ultimo
     }
     ultimo->dato = x; // Asigna el dato leido
     ultimo->enlace = nullptr; // Termina la cadena
     cin >> x; 
  }
}


void escribe(Nodo* h) {
/* Pre: h apunta a la cabeza de una cadena 
   de nodos enlazados */
/* Post: Se han escrito los elementos de la cadena 
 de nodos enlazados a la que apunta h */
  for (Nodo* i = h; i != nullptr; i = i->enlace) {
    cout << " " << i->dato; 
  }
  cout << endl;
}


int main() {
  Nodo* head = nullptr; 
  lee(head); 
  escribe(head);
  
  int v; 
  cin >> v; 
  insert_after(head,v);
  
  cout << "cadena ";
  escribe(head);
}
